﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;
using Telerik.Windows.Controls;
using Telerik.Windows;
using System.Diagnostics;

namespace UploadHandler
{
    public partial class MainPage : UserControl
    {
        private DateTime startTime;
        private DateTime endTime;
        private DateTime lastTime;
        private double timeSpent = 0;

        public MainPage()
        {
            InitializeComponent();                       
        }

        private void radUpload_ProgressChanged(object sender, RoutedEventArgs e)
        {
            if(lastTime != null)
            {
                timeSpent = DateTime.Now.Subtract(lastTime).TotalSeconds;
            }

            double currSpeed = (this.radUpload.BufferSize/1024) / timeSpent;
            if(timeSpent != 0)
            {
                this.currspeedBlock.Text = currSpeed.ToString();
            }
            lastTime = DateTime.Now;
            this.elapsedTimeBlock.Text = DateTime.Now.Subtract(startTime).TotalSeconds.ToString();

            double kbsToGo = (this.radUpload.CurrentSession.CurrentFile.Size / 1024) - this.radUpload.CurrentSession.UploadedBytes / 1024;
            if (currSpeed != 0)
            {
                this.leftTimeBlock.Text = (kbsToGo / currSpeed).ToString();
            }
        }

        private void radUpload_UploadStarted(object sender, UploadStartedEventArgs e)
        {
            this.avgSpeedBlock.Text = "";
            this.currspeedBlock.Text = "";
            this.elapsedTimeBlock.Text = "";
            this.endTimeBlock.Text = "";
            this.leftTimeBlock.Text = "";
            this.starttimeBlock.Text = "";
            this.totalTimeBlock.Text = "";
            timeSpent = 0;
            
            startTime = DateTime.Now;
            this.starttimeBlock.Text = startTime.ToString("HH/mm/ss");
        }

        private void radUpload_UploadFinished(object sender, RoutedEventArgs e)
        {
            endTime = DateTime.Now;
            this.endTimeBlock.Text = endTime.ToString("HH/mm/ss");
            double sec = endTime.Subtract(startTime).TotalSeconds;
            this.totalTimeBlock.Text = sec.ToString() + " sec.";

            if(sec != 0)
            {
                double speed = (this.radUpload.CurrentSession.UploadedBytes / 1024) / sec;
                this.avgSpeedBlock.Text = speed.ToString().Substring(0,5) + "KB / sec.";
            }
        }
	}
}
